package com.cf.imes.module.system.dal.mysql.systemconfig;

import com.cf.imes.framework.common.enums.CommonStatusEnum;
import com.cf.imes.framework.common.pojo.PageResult;
import com.cf.imes.framework.mybatis.core.mapper.BaseMapperX;
import com.cf.imes.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.cf.imes.framework.organ.core.context.OrganContextHolder;
import com.cf.imes.module.system.controller.admin.systemconfig.vo.ConfigPageReqVO;
import com.cf.imes.module.system.dal.dataobject.systemconfig.SystemConfigDO;
import com.cf.imes.module.system.enums.config.SystemConfigTypeEnum;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * 系统配置 Mapper
 *
 * @author Gqr
 * @since 2024/11/7 16:25
 */
@Mapper
public interface SystemConfigMapper extends BaseMapperX<SystemConfigDO> {

    /**
     * 查询列表
     *
     * @param reqVO
     * @return
     */
    default PageResult<SystemConfigDO> selectPage(ConfigPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<SystemConfigDO>()
                .likeIfPresent(SystemConfigDO::getName, reqVO.getName())
                .eqIfPresent(SystemConfigDO::getStatus, reqVO.getStatus())
                .eqIfPresent(SystemConfigDO::getOrganId, OrganContextHolder.getOrganId())
                .select(SystemConfigDO::getId, SystemConfigDO::getName, SystemConfigDO::getStatus, SystemConfigDO::getType)
                .orderByAsc(SystemConfigDO::getId));
    }


    default SystemConfigDO selectDefaultBranching() {
        return selectOne(new LambdaQueryWrapperX<SystemConfigDO>()
                .eqIfPresent(SystemConfigDO::getOrganId, OrganContextHolder.getOrganId())
                .eq(SystemConfigDO::getDeleted,false)
                .eq(SystemConfigDO::getType, SystemConfigTypeEnum.INTELLIGENT_BRANCH.getType())
                .eq(SystemConfigDO::getStatus, CommonStatusEnum.ENABLE.getStatus()));
    }



    default List<SystemConfigDO> selectSystemConfigList(Integer type,Integer status) {
        return selectList(new LambdaQueryWrapperX<SystemConfigDO>()
                .eqIfPresent(SystemConfigDO::getOrganId, OrganContextHolder.getOrganId())
                .eq(SystemConfigDO::getDeleted,false)
                .eq(SystemConfigDO::getType, type)
                .eqIfPresent(SystemConfigDO::getStatus,status)
                .orderByAsc(SystemConfigDO::getSort,SystemConfigDO::getCreateTime));
    }


    /**
     * 查询组织下自定义板编号配置最大版本号
     * @param organId
     * @return
     */
    @Select("select max(version) from system_config where type = 1")
    Integer selectOrgMaxCustomPlateNoSystemConfigVersion(Long organId);
}
